Index: /code/branches/netp4/src/core/ConfigFileManager.cc
===================================================================
--- /code/branches/netp4/src/core/ConfigFileManager.cc	(revision 3122)
+++ /code/branches/netp4/src/core/ConfigFileManager.cc	(revision 3123)
@@ -40,5 +40,4 @@
 namespace orxonox
 {
-    const int CONFIG_FILE_MAX_LINELENGHT  = 1024;
     const char* const DEFAULT_CONFIG_FILE = "default.ini";
 
@@ -244,14 +243,10 @@
         if (file.is_open())
         {
-
-            char linearray[CONFIG_FILE_MAX_LINELENGHT];
-
             ConfigFileSection* newsection = 0;
 
             while (file.good() && !file.eof())
             {
-                file.getline(linearray, CONFIG_FILE_MAX_LINELENGHT);
-
-                std::string line = std::string(linearray);
+                std::string line;
+                std::getline(file, line);
 
                 std::string temp = getStripped(line);
Index: /code/branches/netp4/src/core/ConsoleCommandCompilation.cc
===================================================================
--- /code/branches/netp4/src/core/ConsoleCommandCompilation.cc	(revision 3122)
+++ /code/branches/netp4/src/core/ConsoleCommandCompilation.cc	(revision 3123)
@@ -68,8 +68,8 @@
 
         // Iterate through the file and put the lines into the CommandExecutor
-        char line[1024];
         while (file.good() && !file.eof())
         {
-            file.getline(line, 1024);
+            std::string line;
+            std::getline(file, line);
             CommandExecutor::execute(line);
         }
@@ -139,8 +139,8 @@
 
         std::string output = "";
-        char line[1024];
         while (file.good() && !file.eof())
         {
-            file.getline(line, 1024);
+            std::string line;
+            std::getline(file, line);
             output += line;
             output += "\n";
Index: /code/branches/netp4/src/core/Language.cc
===================================================================
--- /code/branches/netp4/src/core/Language.cc	(revision 3122)
+++ /code/branches/netp4/src/core/Language.cc	(revision 3123)
@@ -224,11 +224,9 @@
         }
 
-        char line[1024];
-
         // Iterate through the file and create the LanguageEntries
         while (file.good() && !file.eof())
         {
-            file.getline(line, 1024);
-            std::string lineString = std::string(line);
+            std::string lineString;
+            std::getline(file, lineString);
 
             // Check if the line is empty
@@ -272,11 +270,9 @@
         }
 
-        char line[1024];
-
         // Iterate through the file and create the LanguageEntries
         while (file.good() && !file.eof())
         {
-            file.getline(line, 1024);
-            std::string lineString = std::string(line);
+            std::string lineString;
+            std::getline(file, lineString);
 
             // Check if the line is empty
Index: /code/branches/netp4/src/core/LuaBind.cc
===================================================================
--- /code/branches/netp4/src/core/LuaBind.cc	(revision 3122)
+++ /code/branches/netp4/src/core/LuaBind.cc	(revision 3123)
@@ -97,10 +97,10 @@
     }
 
-    char line[1024*32];
     std::string levelString = "";
 
     while (file.good() && !file.eof())
     {
-      file.getline(line, 1024*32);
+      std::string line;
+      std::getline(file, line);
       levelString += line;
       levelString += "\n";
Index: /code/branches/netp4/src/util/OutputBuffer.cc
===================================================================
--- /code/branches/netp4/src/util/OutputBuffer.cc	(revision 3122)
+++ /code/branches/netp4/src/util/OutputBuffer.cc	(revision 3123)
@@ -36,6 +36,4 @@
 namespace orxonox
 {
-    const int OUTPUTBUFFER_MAX_LINE_LENGTH = 16384; //! The maximal number of lines that can be stored within the OutputBuffer.
-
     /**
         @brief Adds a new listener to the list.
@@ -105,8 +103,5 @@
     bool OutputBuffer::getLine(std::string* output)
     {
-        char line[OUTPUTBUFFER_MAX_LINE_LENGTH];
-
-        this->stream_.getline(line, OUTPUTBUFFER_MAX_LINE_LENGTH);
-        (*output) = std::string(line);
+        std::getline(this->stream_, *output);
 
         bool eof = this->stream_.eof();