Index: code/branches/pch/src/orxonox/objects/Scene.cc
===================================================================
--- code/branches/pch/src/orxonox/objects/Scene.cc	(revision 3118)
+++ code/branches/pch/src/orxonox/objects/Scene.cc	(revision 3125)
@@ -139,5 +139,5 @@
         {
             CCOUT(2) << "Warning: Setting the negative world range to a very small value: "
-                     << omni_cast<std::string>(range) << std::endl;
+                     << multi_cast<std::string>(range) << std::endl;
         }
         if (this->hasPhysics())
@@ -158,5 +158,5 @@
         {
             CCOUT(2) << "Warning: Setting the positive world range to a very small value: "
-                     << omni_cast<std::string>(range) << std::endl;
+                     << multi_cast<std::string>(range) << std::endl;
         }
         if (this->hasPhysics())
@@ -176,5 +176,5 @@
         this->gravity_ = gravity;
         if (this->hasPhysics())
-            this->physicalWorld_->setGravity(omni_cast<btVector3>(this->gravity_));
+            this->physicalWorld_->setGravity(multi_cast<btVector3>(this->gravity_));
     }
 
@@ -187,5 +187,5 @@
             //       It would require further investigation to properly dertermine the right choices.
             this->broadphase_      = new bt32BitAxisSweep3(
-                omni_cast<btVector3>(this->negativeWorldRange_), omni_cast<btVector3>(this->positiveWorldRange_));
+                multi_cast<btVector3>(this->negativeWorldRange_), multi_cast<btVector3>(this->positiveWorldRange_));
             this->collisionConfig_ = new btDefaultCollisionConfiguration();
             this->dispatcher_      = new btCollisionDispatcher(this->collisionConfig_);
@@ -193,5 +193,5 @@
 
             this->physicalWorld_   = new btDiscreteDynamicsWorld(this->dispatcher_, this->broadphase_, this->solver_, this->collisionConfig_);
-            this->physicalWorld_->setGravity(omni_cast<btVector3>(this->gravity_));
+            this->physicalWorld_->setGravity(multi_cast<btVector3>(this->gravity_));
 
             // also set the collision callback variable.
Index: code/branches/pch/src/orxonox/objects/collisionshapes/BoxCollisionShape.cc
===================================================================
--- code/branches/pch/src/orxonox/objects/collisionshapes/BoxCollisionShape.cc	(revision 3118)
+++ code/branches/pch/src/orxonox/objects/collisionshapes/BoxCollisionShape.cc	(revision 3125)
@@ -72,5 +72,5 @@
     btCollisionShape* BoxCollisionShape::createNewShape() const
     {
-        return new btBoxShape(omni_cast<btVector3>(this->halfExtents_));
+        return new btBoxShape(multi_cast<btVector3>(this->halfExtents_));
     }
 }
Index: code/branches/pch/src/orxonox/objects/collisionshapes/CompoundCollisionShape.cc
===================================================================
--- code/branches/pch/src/orxonox/objects/collisionshapes/CompoundCollisionShape.cc	(revision 3118)
+++ code/branches/pch/src/orxonox/objects/collisionshapes/CompoundCollisionShape.cc	(revision 3125)
@@ -89,5 +89,5 @@
         {
             // Only actually attach if we didn't pick a CompoundCollisionShape with no content
-            btTransform transf(omni_cast<btQuaternion>(shape->getOrientation()), omni_cast<btVector3>(shape->getPosition()));
+            btTransform transf(multi_cast<btQuaternion>(shape->getOrientation()), multi_cast<btVector3>(shape->getPosition()));
             this->compoundShape_->addChildShape(transf, shape->getCollisionShape());
 
@@ -134,5 +134,5 @@
         {
             // Only actually attach if we didn't pick a CompoundCollisionShape with no content
-            btTransform transf(omni_cast<btQuaternion>(shape->getOrientation()), omni_cast<btVector3>(shape->getPosition()));
+            btTransform transf(multi_cast<btQuaternion>(shape->getOrientation()), multi_cast<btVector3>(shape->getPosition()));
             this->compoundShape_->addChildShape(transf, shape->getCollisionShape());
             it->second = shape->getCollisionShape();
Index: code/branches/pch/src/orxonox/objects/collisionshapes/PlaneCollisionShape.cc
===================================================================
--- code/branches/pch/src/orxonox/objects/collisionshapes/PlaneCollisionShape.cc	(revision 3118)
+++ code/branches/pch/src/orxonox/objects/collisionshapes/PlaneCollisionShape.cc	(revision 3125)
@@ -72,5 +72,5 @@
     btCollisionShape* PlaneCollisionShape::createNewShape() const
     {
-        return new btStaticPlaneShape(omni_cast<btVector3>(this->normal_), this->offset_);
+        return new btStaticPlaneShape(multi_cast<btVector3>(this->normal_), this->offset_);
     }
 }
Index: code/branches/pch/src/orxonox/overlays/stats/Scoreboard.cc
===================================================================
--- code/branches/pch/src/orxonox/overlays/stats/Scoreboard.cc	(revision 3118)
+++ code/branches/pch/src/orxonox/overlays/stats/Scoreboard.cc	(revision 3125)
@@ -101,7 +101,7 @@
         for (std::map<PlayerInfo*, Player>::const_iterator it = playerList.begin(); it != playerList.end(); ++it)
         {
-            this->lines_[index]->setPlayerName(omni_cast<std::string>(it->first->getName()));
-            this->lines_[index]->setScore(omni_cast<std::string>(it->second.frags_));
-            this->lines_[index]->setDeaths(omni_cast<std::string>(it->second.killed_));
+            this->lines_[index]->setPlayerName(multi_cast<std::string>(it->first->getName()));
+            this->lines_[index]->setScore(multi_cast<std::string>(it->second.frags_));
+            this->lines_[index]->setDeaths(multi_cast<std::string>(it->second.killed_));
             index++;
         }