Index: code/branches/pch/src/orxonox/CameraManager.cc
===================================================================
--- code/branches/pch/src/orxonox/CameraManager.cc	(revision 3130)
+++ code/branches/pch/src/orxonox/CameraManager.cc	(revision 3131)
@@ -30,14 +30,12 @@
 #include <OgreSceneManager.h>
 #include <OgreViewport.h>
-#include <OgreCamera.h>
 #include <OgreCompositorManager.h>
-#include <OgreResource.h>
 
+#include "util/String.h"
 #include "core/GameMode.h"
 #include "core/Iterator.h"
+#include "tools/Shader.h"
 #include "objects/worldentities/Camera.h"
 #include "objects/Scene.h"
-#include "tools/Shader.h"
-#include "util/String.h"
 #include "gui/GUIManager.h"
 
Index: code/branches/pch/src/orxonox/CameraManager.h
===================================================================
--- code/branches/pch/src/orxonox/CameraManager.h	(revision 3130)
+++ code/branches/pch/src/orxonox/CameraManager.h	(revision 3131)
@@ -55,15 +55,15 @@
             void releaseFocus(Camera* camera);
 
+            void useCamera(Ogre::Camera* camera);
+
             static CameraManager& getInstance() { assert(singletonRef_s); return *singletonRef_s; }
             static CameraManager* getInstancePtr() { return singletonRef_s; }
 
-            void useCamera(Ogre::Camera* camera);
+        private:
+            CameraManager(const CameraManager&); // don't use
 
-        private:
-            CameraManager(const CameraManager&);
-
-            std::list<Camera*> cameraList_;
-            Ogre::Viewport* viewport_;
-            Ogre::Camera* fallbackCamera_;
+            std::list<Camera*>    cameraList_;
+            Ogre::Viewport*       viewport_;
+            Ogre::Camera*         fallbackCamera_;
 
             static CameraManager* singletonRef_s;
Index: code/branches/pch/src/orxonox/GraphicsManager.cc
===================================================================
--- code/branches/pch/src/orxonox/GraphicsManager.cc	(revision 3130)
+++ code/branches/pch/src/orxonox/GraphicsManager.cc	(revision 3131)
@@ -88,6 +88,4 @@
         , viewport_(0)
         , ogreWindowEventListener_(0)
-        , avgTickTime_(0.0f)
-        , avgFramesPerSecond_(0.0f)
     {
         RegisterObject(GraphicsManager);
Index: code/branches/pch/src/orxonox/GraphicsManager.h
===================================================================
--- code/branches/pch/src/orxonox/GraphicsManager.h	(revision 3130)
+++ code/branches/pch/src/orxonox/GraphicsManager.h	(revision 3131)
@@ -39,8 +39,7 @@
 #include "OrxonoxPrereqs.h"
 
+#include <cassert>
 #include <string>
-#include <cassert>
 #include <OgreLog.h>
-
 #include "core/OrxonoxClass.h"
 
@@ -66,5 +65,5 @@
             { return this->detailLevelParticle_; }
 
-        inline Ogre::Viewport* getViewport() const
+        inline Ogre::Viewport* getViewport()
             { return this->viewport_; }
         inline Ogre::RenderWindow* getRenderWindow()
@@ -73,5 +72,6 @@
         void setCamera(Ogre::Camera* camera);
 
-        static GraphicsManager& getInstance() { assert(singletonRef_s); return *singletonRef_s; }
+        inline static GraphicsManager& getInstance()
+            { assert(singletonRef_s); return *singletonRef_s; }
 
     private:
@@ -101,8 +101,4 @@
         OgreWindowEventListener* ogreWindowEventListener_;
 
-        // stats (Hack)
-        float               avgTickTime_;              //!< time in ms to tick() one frame
-        float               avgFramesPerSecond_;       //!< number of frames processed in one second
-
         // config values
         unsigned int        detailLevelParticle_;      //!< Detail level of particle effects (0: off, 1: low, 2: normal, 3: high)
Index: code/branches/pch/src/orxonox/LevelManager.cc
===================================================================
--- code/branches/pch/src/orxonox/LevelManager.cc	(revision 3130)
+++ code/branches/pch/src/orxonox/LevelManager.cc	(revision 3131)
@@ -29,4 +29,5 @@
 #include "LevelManager.h"
 
+#include <map>
 #include "PlayerManager.h"
 #include "objects/Level.h"
Index: code/branches/pch/src/orxonox/LevelManager.h
===================================================================
--- code/branches/pch/src/orxonox/LevelManager.h	(revision 3130)
+++ code/branches/pch/src/orxonox/LevelManager.h	(revision 3131)
@@ -32,7 +32,6 @@
 #include "OrxonoxPrereqs.h"
 
+#include <cassert>
 #include <list>
-#include <map>
-#include <cassert>
 
 namespace orxonox
@@ -57,4 +56,5 @@
 
             std::list<Level*> levels_s;
+
             static LevelManager* singletonRef_s;
     };
Index: code/branches/pch/src/orxonox/PawnManager.cc
===================================================================
--- code/branches/pch/src/orxonox/PawnManager.cc	(revision 3130)
+++ code/branches/pch/src/orxonox/PawnManager.cc	(revision 3131)
@@ -31,5 +31,4 @@
 #include "core/CoreIncludes.h"
 #include "objects/worldentities/pawns/Pawn.h"
-
 
 namespace orxonox
Index: code/branches/pch/src/orxonox/PlayerManager.cc
===================================================================
--- code/branches/pch/src/orxonox/PlayerManager.cc	(revision 3130)
+++ code/branches/pch/src/orxonox/PlayerManager.cc	(revision 3131)
@@ -29,9 +29,9 @@
 #include "PlayerManager.h"
 
-#include "LevelManager.h"
+#include "core/CoreIncludes.h"
 #include "core/GameMode.h"
-#include "core/CoreIncludes.h"
 #include "objects/Level.h"
 #include "objects/infos/HumanPlayer.h"
+#include "LevelManager.h"
 
 namespace orxonox
Index: code/branches/pch/src/orxonox/PlayerManager.h
===================================================================
--- code/branches/pch/src/orxonox/PlayerManager.h	(revision 3130)
+++ code/branches/pch/src/orxonox/PlayerManager.h	(revision 3131)
@@ -44,6 +44,6 @@
             virtual ~PlayerManager();
 
-            static PlayerManager& getInstance()
-            { assert(singletonRef_s); return *singletonRef_s; }
+            inline static PlayerManager& getInstance()
+                { assert(singletonRef_s); return *singletonRef_s; }
 
             PlayerInfo* getClient(unsigned int clientID) const;
Index: code/branches/pch/src/orxonox/tools/BillboardSet.cc
===================================================================
--- code/branches/pch/src/orxonox/tools/BillboardSet.cc	(revision 3130)
+++ code/branches/pch/src/orxonox/tools/BillboardSet.cc	(revision 3131)
@@ -31,12 +31,12 @@
 #include <sstream>
 #include <cassert>
-
 #include <OgreSceneManager.h>
 #include <OgreBillboardSet.h>
 #include <OgreBillboard.h>
 
+#include "util/Convert.h"
+#include "util/Math.h"
+#include "util/String.h"
 #include "core/GameMode.h"
-#include "util/Convert.h"
-#include "util/String.h"
 
 namespace orxonox
Index: code/branches/pch/src/orxonox/tools/BillboardSet.h
===================================================================
--- code/branches/pch/src/orxonox/tools/BillboardSet.h	(revision 3130)
+++ code/branches/pch/src/orxonox/tools/BillboardSet.h	(revision 3131)
@@ -34,6 +34,5 @@
 #include <string>
 #include <OgrePrerequisites.h>
-
-#include "util/Math.h"
+#include "util/UtilPrereqs.h"
 
 namespace orxonox
@@ -52,5 +51,5 @@
             inline Ogre::BillboardSet* getBillboardSet()
                 { return this->billboardSet_; }
-            inline Ogre::SceneManager* getSceneManager()
+            inline Ogre::SceneManager* getSceneManager() const
                 { return this->scenemanager_; }
 
@@ -69,7 +68,8 @@
             void destroyBillboardSet();
 
-            static unsigned int billboardSetCounter_s;
             Ogre::BillboardSet* billboardSet_;
             Ogre::SceneManager* scenemanager_;
+
+            static unsigned int billboardSetCounter_s;
     };
 }
Index: code/branches/pch/src/orxonox/tools/CMakeLists.txt
===================================================================
--- code/branches/pch/src/orxonox/tools/CMakeLists.txt	(revision 3130)
+++ code/branches/pch/src/orxonox/tools/CMakeLists.txt	(revision 3131)
@@ -1,4 +1,6 @@
 ADD_SOURCE_FILES(ORXONOX_SRC_FILES
   BillboardSet.cc
+  DynamicLines.cc
+  DynamicRenderable.cc
   Mesh.cc
   ParticleInterface.cc
@@ -8,5 +10,3 @@
   Timer.cc
   WindowEventListener.cc
-  DynamicLines.cpp
-  DynamicRenderable.cpp
 )
Index: code/branches/pch/src/orxonox/tools/Mesh.cc
===================================================================
--- code/branches/pch/src/orxonox/tools/Mesh.cc	(revision 3130)
+++ code/branches/pch/src/orxonox/tools/Mesh.cc	(revision 3131)
@@ -29,12 +29,12 @@
 #include "Mesh.h"
 
+#include <cassert>
 #include <sstream>
 #include <OgreEntity.h>
 #include <OgreSceneManager.h>
-#include <cassert>
 
-#include "core/GameMode.h"
 #include "util/Convert.h"
 #include "util/String.h"
+#include "core/GameMode.h"
 
 namespace orxonox
Index: code/branches/pch/src/orxonox/tools/Mesh.h
===================================================================
--- code/branches/pch/src/orxonox/tools/Mesh.h	(revision 3130)
+++ code/branches/pch/src/orxonox/tools/Mesh.h	(revision 3131)
@@ -58,8 +58,9 @@
 
         private:
-            static unsigned int meshCounter_s;
             Ogre::Entity* entity_;
             bool bCastShadows_;
             Ogre::SceneManager* scenemanager_;
+
+            static unsigned int meshCounter_s;
     };
 }
Index: code/branches/pch/src/orxonox/tools/ParticleInterface.cc
===================================================================
--- code/branches/pch/src/orxonox/tools/ParticleInterface.cc	(revision 3130)
+++ code/branches/pch/src/orxonox/tools/ParticleInterface.cc	(revision 3131)
@@ -34,13 +34,14 @@
 #include "ParticleInterface.h"
 
+#include <cassert>
 #include <OgreParticleSystem.h>
 #include <OgreParticleEmitter.h>
 #include <OgreSceneManager.h>
-#include <cassert>
-
+
+#include "util/Convert.h"
+#include "util/Math.h"
+#include "core/CoreIncludes.h"
+#include "core/GameMode.h"
 #include "GraphicsManager.h"
-#include "core/GameMode.h"
-#include "core/CoreIncludes.h"
-#include "util/Convert.h"
 
 namespace orxonox
@@ -132,5 +133,5 @@
             return 0;
     }
-    Ogre::ParticleAffector* ParticleInterface::getAffector(unsigned int affectorNr) const
+    Ogre::ParticleAffector* ParticleInterface::getAffector(unsigned int affectorNr)
     {
         if (this->particleSystem_ && (affectorNr < this->particleSystem_->getNumAffectors()))
Index: code/branches/pch/src/orxonox/tools/ParticleInterface.h
===================================================================
--- code/branches/pch/src/orxonox/tools/ParticleInterface.h	(revision 3130)
+++ code/branches/pch/src/orxonox/tools/ParticleInterface.h	(revision 3131)
@@ -34,7 +34,4 @@
 #include <string>
 #include <OgrePrerequisites.h>
-
-#include "core/OrxonoxClass.h"
-#include "util/Math.h"
 #include "tools/TimeFactorListener.h"
 
@@ -52,5 +49,5 @@
             virtual ~ParticleInterface();
 
-            inline Ogre::ParticleSystem* getParticleSystem() const
+            inline Ogre::ParticleSystem* getParticleSystem()
                 { return this->particleSystem_; }
 
@@ -62,5 +59,5 @@
 
             Ogre::ParticleAffector* addAffector(const std::string& name);
-            Ogre::ParticleAffector* getAffector(unsigned int affectorNr) const;
+            Ogre::ParticleAffector* getAffector(unsigned int affectorNr);
             void removeAffector(unsigned int affectorNr);
             void removeAllAffectors();
@@ -95,8 +92,6 @@
             void updateVisibility();
 
-            static ParticleInterface* currentParticleInterface_s;
-            static unsigned int       counter_s;
-
             Ogre::ParticleSystem*     particleSystem_;
+            Ogre::SceneManager*       scenemanager_;
             bool                      bVisible_;
             bool                      bEnabled_;
@@ -104,5 +99,7 @@
             unsigned int              detaillevel_;     //!< Detail level of this particle effect (0: off, 1: low, 2: normal, 3: high)
             float                     speedFactor_;
-            Ogre::SceneManager*       scenemanager_;
+
+            static ParticleInterface* currentParticleInterface_s;
+            static unsigned int       counter_s;
     };
 }
Index: code/branches/pch/src/orxonox/tools/Shader.cc
===================================================================
--- code/branches/pch/src/orxonox/tools/Shader.cc	(revision 3130)
+++ code/branches/pch/src/orxonox/tools/Shader.cc	(revision 3131)
@@ -34,15 +34,12 @@
 #include <OgreRoot.h>
 #include <OgrePlugin.h>
-
-#include "core/GameMode.h"
-#include "core/CoreIncludes.h"
-#include "core/Executor.h"
-#include "GraphicsManager.h"
-#include "util/Exception.h"
-
 #include <OgreMaterial.h>
 #include <OgreTechnique.h>
 #include <OgrePass.h>
 #include <OgreMaterialManager.h>
+
+#include "core/CoreIncludes.h"
+#include "core/GameMode.h"
+#include "GraphicsManager.h"
 
 namespace orxonox
Index: code/branches/pch/src/orxonox/tools/Shader.h
===================================================================
--- code/branches/pch/src/orxonox/tools/Shader.h	(revision 3130)
+++ code/branches/pch/src/orxonox/tools/Shader.h	(revision 3131)
@@ -31,7 +31,9 @@
 
 #include "OrxonoxPrereqs.h"
+
+#include <map>
+#include <string>
+#include <vector>
 #include <OgrePrerequisites.h>
-#include <vector>
-#include <map>
 
 #include "objects/Tickable.h"
Index: code/branches/pch/src/orxonox/tools/TextureGenerator.cc
===================================================================
--- code/branches/pch/src/orxonox/tools/TextureGenerator.cc	(revision 3130)
+++ code/branches/pch/src/orxonox/tools/TextureGenerator.cc	(revision 3131)
@@ -33,7 +33,9 @@
 
 #include "TextureGenerator.h"
+
 #include <OgreMaterialManager.h>
 #include <OgreTechnique.h>
 #include "util/Convert.h"
+#include "util/Math.h"
 
 namespace std
Index: code/branches/pch/src/orxonox/tools/TextureGenerator.h
===================================================================
--- code/branches/pch/src/orxonox/tools/TextureGenerator.h	(revision 3130)
+++ code/branches/pch/src/orxonox/tools/TextureGenerator.h	(revision 3131)
@@ -36,7 +36,8 @@
 
 #include "OrxonoxPrereqs.h"
+
+#include <map>
 #include <string>
-#include <map>
-#include "util/Math.h"
+#include "util/UtilPrereqs.h"
 
 namespace orxonox
Index: code/branches/pch/src/orxonox/tools/TimeFactorListener.h
===================================================================
--- code/branches/pch/src/orxonox/tools/TimeFactorListener.h	(revision 3130)
+++ code/branches/pch/src/orxonox/tools/TimeFactorListener.h	(revision 3131)
@@ -33,5 +33,4 @@
 #include "core/OrxonoxClass.h"
 
-
 namespace orxonox
 {
Index: code/branches/pch/src/orxonox/tools/Timer.cc
===================================================================
--- code/branches/pch/src/orxonox/tools/Timer.cc	(revision 3130)
+++ code/branches/pch/src/orxonox/tools/Timer.cc	(revision 3131)
@@ -27,13 +27,13 @@
  */
 
+#include "Timer.h"
+
 #include <set>
 
-#include "Timer.h"
-
-#include "core/Executor.h"
 #include "core/CoreIncludes.h"
 #include "core/ConsoleCommand.h"
 #include "core/CommandExecutor.h"
 #include "core/Clock.h"
+#include "core/Functor.h"
 
 namespace orxonox
Index: code/branches/pch/src/orxonox/tools/Timer.h
===================================================================
--- code/branches/pch/src/orxonox/tools/Timer.h	(revision 3130)
+++ code/branches/pch/src/orxonox/tools/Timer.h	(revision 3131)
@@ -62,4 +62,5 @@
 
 #include "OrxonoxPrereqs.h"
+
 #include "core/Executor.h"
 #include "core/OrxonoxClass.h"
Index: code/branches/pch/src/orxonox/tools/WindowEventListener.h
===================================================================
--- code/branches/pch/src/orxonox/tools/WindowEventListener.h	(revision 3130)
+++ code/branches/pch/src/orxonox/tools/WindowEventListener.h	(revision 3131)
@@ -33,5 +33,4 @@
 #include "core/OrxonoxClass.h"
 
-
 namespace orxonox
 {