Index: code/branches/pch/src/orxonox/overlays/notifications/Notification.cc
===================================================================
--- code/branches/pch/src/orxonox/overlays/notifications/Notification.cc	(revision 3114)
+++ code/branches/pch/src/orxonox/overlays/notifications/Notification.cc	(revision 3144)
@@ -35,6 +35,4 @@
 
 #include "core/CoreIncludes.h"
-#include "util/Exception.h"
-
 #include "NotificationManager.h"
 
@@ -48,4 +46,5 @@
     Notification::Notification(BaseObject* creator) : BaseObject(creator)
     {
+        RegisterObject(Notification);
         this->initialize();
     }
@@ -76,6 +75,4 @@
     void Notification::initialize(void)
     {
-        RegisterObject(Notification);
-        
         this->message_ = "";
         this->sender_ = NotificationManager::NONE;
Index: code/branches/pch/src/orxonox/overlays/notifications/Notification.h
===================================================================
--- code/branches/pch/src/orxonox/overlays/notifications/Notification.h	(revision 3114)
+++ code/branches/pch/src/orxonox/overlays/notifications/Notification.h	(revision 3144)
@@ -38,5 +38,4 @@
 
 #include <string>
-
 #include "core/BaseObject.h"
 
Index: code/branches/pch/src/orxonox/overlays/notifications/NotificationManager.cc
===================================================================
--- code/branches/pch/src/orxonox/overlays/notifications/NotificationManager.cc	(revision 3114)
+++ code/branches/pch/src/orxonox/overlays/notifications/NotificationManager.cc	(revision 3144)
@@ -34,8 +34,7 @@
 #include "NotificationManager.h"
 
+#include <set>
+
 #include "core/CoreIncludes.h"
-
-#include <set>
-
 #include "Notification.h"
 #include "NotificationQueue.h"
Index: code/branches/pch/src/orxonox/overlays/notifications/NotificationManager.h
===================================================================
--- code/branches/pch/src/orxonox/overlays/notifications/NotificationManager.h	(revision 3114)
+++ code/branches/pch/src/orxonox/overlays/notifications/NotificationManager.h	(revision 3144)
@@ -37,11 +37,8 @@
 #include "OrxonoxPrereqs.h"
 
-#include "core/OrxonoxClass.h"
-
+#include <ctime>
 #include <map>
 #include <string>
-#include <ctime>
-
-#include "NotificationOverlay.h"
+#include "core/OrxonoxClass.h"
 
 namespace orxonox
Index: code/branches/pch/src/orxonox/overlays/notifications/NotificationOverlay.cc
===================================================================
--- code/branches/pch/src/orxonox/overlays/notifications/NotificationOverlay.cc	(revision 3114)
+++ code/branches/pch/src/orxonox/overlays/notifications/NotificationOverlay.cc	(revision 3144)
@@ -34,11 +34,6 @@
 #include "NotificationOverlay.h"
 
-#include <OgreOverlayManager.h>
-#include <OgreTextAreaOverlayElement.h>
-#include <OgrePanelOverlayElement.h>
-
+#include "util/Exception.h"
 #include "core/CoreIncludes.h"
-#include "util/Exception.h"
-
 #include "Notification.h"
 #include "NotificationQueue.h"
@@ -53,4 +48,5 @@
     NotificationOverlay::NotificationOverlay(BaseObject* creator) : OverlayText(creator)
     {
+        RegisterObject(NotificationOverlay);
         this->initialize();
     }
@@ -87,6 +83,4 @@
     void NotificationOverlay::initialize(void)
     {
-        RegisterObject(NotificationOverlay);
-        
         this->queue_ = NULL;
     }
Index: code/branches/pch/src/orxonox/overlays/notifications/NotificationOverlay.h
===================================================================
--- code/branches/pch/src/orxonox/overlays/notifications/NotificationOverlay.h	(revision 3114)
+++ code/branches/pch/src/orxonox/overlays/notifications/NotificationOverlay.h	(revision 3144)
@@ -38,10 +38,6 @@
 #include "OrxonoxPrereqs.h"
 
+#include <string>
 #include "orxonox/overlays/OverlayText.h"
-
-#include <string>
-#include <set>
-#include <OgrePrerequisites.h>
-#include <OgreTextAreaOverlayElement.h>
 
 namespace orxonox
Index: code/branches/pch/src/orxonox/overlays/notifications/NotificationQueue.cc
===================================================================
--- code/branches/pch/src/orxonox/overlays/notifications/NotificationQueue.cc	(revision 3114)
+++ code/branches/pch/src/orxonox/overlays/notifications/NotificationQueue.cc	(revision 3144)
@@ -34,15 +34,10 @@
 #include "NotificationQueue.h"
 
-#include <OgreOverlayManager.h>
-#include <OgreTextAreaOverlayElement.h>
-#include <list>
-#include <iostream>
 #include <sstream>
 
 #include "core/CoreIncludes.h"
 #include "core/XMLPort.h"
-
-#include "Notification.h"
 #include "NotificationOverlay.h"
+#include "NotificationManager.h"
 
 namespace orxonox
@@ -61,4 +56,5 @@
     NotificationQueue::NotificationQueue(BaseObject* creator) : OverlayGroup(creator)
     {
+        RegisterObject(NotificationQueue);
         this->initialize();
     }
@@ -81,6 +77,4 @@
     void NotificationQueue::initialize(void)
     {
-        RegisterObject(NotificationQueue);
-
         this->size_ = 0;
         this->tickTime_ = 0.0;
Index: code/branches/pch/src/orxonox/overlays/notifications/NotificationQueue.h
===================================================================
--- code/branches/pch/src/orxonox/overlays/notifications/NotificationQueue.h	(revision 3114)
+++ code/branches/pch/src/orxonox/overlays/notifications/NotificationQueue.h	(revision 3144)
@@ -37,16 +37,12 @@
 #include "OrxonoxPrereqs.h"
 
+#include <ctime>
+#include <map>
+#include <set>
 #include <string>
-#include <set>
-#include <OgreOverlayManager.h>
-#include <OgreTextAreaOverlayElement.h>
-#include <OgrePanelOverlayElement.h>
-#include <map>
-#include <ctime>
-
+
+#include "util/Math.h"
+#include "orxonox/objects/Tickable.h"
 #include "orxonox/overlays/OverlayGroup.h"
-#include "orxonox/objects/Tickable.h"
-
-#include "NotificationManager.h"
 
 namespace orxonox